﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;
using System.Windows.Input;
using System.IO;
using System.Net;
using System.Net.Sockets;
//using System.Threading;

namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        //Variables to hold the controls
        Keys aButton;
        Keys bButton;
        Keys xButton;
        Keys yButton;
        Keys lButton;
        Keys rButton;
        Keys upButton;
        Keys downButton;
        Keys leftButton;
        Keys rightButton;
        Keys selectButton;
        Keys startButton;

        //Array to hold contents of controls.txt
        string[] controlInput = new string[13];

        string clientIPAddress;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Set the controls
            try
            {
                //Load the controls from controls.txt
                string[] lines = System.IO.File.ReadAllLines(@"controls.txt");

                int x = 0;

                foreach (string line in lines)
                {
                    controlInput[x] = line;
                    x++;
                }
                
                //Update controls from controls.txt - convert strings to Keys
                TypeConverter converter = TypeDescriptor.GetConverter(typeof(Keys));    

                aButton = (Keys)converter.ConvertFromString(controlInput[0]);
                bButton = (Keys)converter.ConvertFromString(controlInput[1]);
                yButton = (Keys)converter.ConvertFromString(controlInput[2]);
                xButton = (Keys)converter.ConvertFromString(controlInput[3]);
                leftButton = (Keys)converter.ConvertFromString(controlInput[4]);
                rightButton = (Keys)converter.ConvertFromString(controlInput[5]);
                upButton = (Keys)converter.ConvertFromString(controlInput[6]);
                downButton = (Keys)converter.ConvertFromString(controlInput[7]);
                startButton = (Keys)converter.ConvertFromString(controlInput[8]);
                selectButton = (Keys)converter.ConvertFromString(controlInput[9]);
                lButton = (Keys)converter.ConvertFromString(controlInput[10]);
                rButton = (Keys)converter.ConvertFromString(controlInput[11]);
                clientIPAddress = controlInput[12];

                //Update the labels on the form
                lblA.Text = controlInput[0];
                lblB.Text = controlInput[1];
                lblY.Text = controlInput[2];
                lblX.Text = controlInput[3];
                lblLeft.Text = controlInput[4];
                lblRight.Text = controlInput[5];
                lblUp.Text = controlInput[6];
                lblDown.Text = controlInput[7];
                lblStart.Text = controlInput[8];
                lblSelect.Text = controlInput[9];
                lblL.Text = controlInput[10];
                lblR.Text = controlInput[11];
                lblServerIP.Text = controlInput[12]+ ":80";

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error with controls.txt: ", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        protected override void OnKeyDown(System.Windows.Forms.KeyEventArgs e)
        {
            keyDownHandler(e);
        }

        protected override void OnKeyUp(System.Windows.Forms.KeyEventArgs e)
        {
            keyReleaseHandler(e);
        }

        void keyDownHandler(System.Windows.Forms.KeyEventArgs e)
        {
            if (e.KeyCode == aButton)
                keyAction("A");
            else if (e.KeyCode == bButton)
                keyAction("B");
            else if (e.KeyCode == yButton)
                keyAction("Y");
            else if (e.KeyCode == xButton)
                keyAction("X");
            else if (e.KeyCode == leftButton)
                keyAction("L");
            else if (e.KeyCode == rightButton)
                keyAction("R");
            else if (e.KeyCode == upButton)
                keyAction("U");
            else if (e.KeyCode == downButton)
                keyAction("D");
            else if (e.KeyCode == startButton)
                keyAction("S");
            else if (e.KeyCode == selectButton)
                keyAction("Z");
            else if (e.KeyCode == lButton)
                keyAction("Q");
            else if (e.KeyCode == rButton)
                keyAction("W");    
        }

        void keyReleaseHandler(System.Windows.Forms.KeyEventArgs e)
        {
            if (e.KeyCode == aButton)
                keyAction("1");
            else if (e.KeyCode == bButton)
                keyAction("2");
            else if (e.KeyCode == yButton)
                keyAction("3");
            else if (e.KeyCode == xButton)
                keyAction("4");
            else if (e.KeyCode == leftButton)
                keyAction("5");
            else if (e.KeyCode == rightButton)
                keyAction("6");
            else if (e.KeyCode == upButton)
                keyAction("7");
            else if (e.KeyCode == downButton)
                keyAction("8");
            else if (e.KeyCode == startButton)
                keyAction("9");
            else if (e.KeyCode == selectButton)
                keyAction("P");
            else if (e.KeyCode == lButton)
                keyAction("O");
            else if (e.KeyCode == rButton)
                keyAction("I");   
        }

        void keyAction(string button)
        {
            try
            {
                TcpClient tcpClient = new TcpClient();

                tcpClient.Connect(clientIPAddress, 80);

                lblcomStatus.Text = "CONNECTED TO SERVER";

                String input = button;
                Stream stream = tcpClient.GetStream();

                ASCIIEncoding asen = new ASCIIEncoding();
                byte[] ba = asen.GetBytes(input);
                stream.Write(ba, 0, ba.Length);

                //serialPort.Write(button);
                statusLabelHandler(button);

                byte[] bb = new byte[100];
                int k = stream.Read(bb, 0, 100);

                for (int i = 0; i < k; i++)
                    Console.Write(Convert.ToChar(bb[i]));

                tcpClient.Close();
            }
            catch
            {
                MessageBox.Show("Problem connecting to server.");
                lblcomStatus.Text = "PROBLEM. DISCONNECTED FROM SERVER";
            }
        }

        void statusLabelHandler(string button)
        {
            switch (button)
            {
                case "A": { lblButtonStatus.Text = "A PRESS";       break; }
                case "1": { lblButtonStatus.Text = "A RELEASE";     break; }
                case "B": { lblButtonStatus.Text = "B PRESS";       break; }
                case "2": { lblButtonStatus.Text = "B RELEASE";     break; }
                case "Y": { lblButtonStatus.Text = "Y PRESS";       break; }
                case "3": { lblButtonStatus.Text = "Y RELEASE";     break; }
                case "X": { lblButtonStatus.Text = "X PRESS";       break; }
                case "4": { lblButtonStatus.Text = "X RELEASE";     break; }
                case "L": { lblButtonStatus.Text = "LEFT PRESS";    break; }
                case "5": { lblButtonStatus.Text = "LEFT RELEASE";  break; }
                case "R": { lblButtonStatus.Text = "RIGHT PRESS";   break; }
                case "6": { lblButtonStatus.Text = "RIGHT RELEASE"; break; }
                case "U": { lblButtonStatus.Text = "UP PRESS";      break; }
                case "7": { lblButtonStatus.Text = "UP RELEASE";    break; }
                case "D": { lblButtonStatus.Text = "DOWN PRESS";    break; }
                case "8": { lblButtonStatus.Text = "DOWN RELEASE";  break; }
                case "S": { lblButtonStatus.Text = "START PRESS";   break; }
                case "9": { lblButtonStatus.Text = "START RELEASE"; break; }
                case "Z": { lblButtonStatus.Text = "SELECT PRESS";  break; }
                case "P": { lblButtonStatus.Text = "SELECT RELEASE";break; }
                case "Q": { lblButtonStatus.Text = "L PRESS";       break; }
                case "O": { lblButtonStatus.Text = "L RELEASE";     break; }
                case "W": { lblButtonStatus.Text = "R PRESS";       break; }
                case "I": { lblButtonStatus.Text = "R RELEASE";     break; }
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            serialPort.Close();
        }
    }
}
